Index: trunk/MagicSoft/Mars/manalysis/MPedestalCam.h
===================================================================
--- trunk/MagicSoft/Mars/manalysis/MPedestalCam.h	(revision 2961)
+++ trunk/MagicSoft/Mars/manalysis/MPedestalCam.h	(revision 2969)
@@ -19,4 +19,9 @@
     TClonesArray *fArray; // FIXME: Change TClonesArray away from a pointer?
 
+    ULong_t fNumTotSlices;
+    Byte_t  fNumExtractSlices;
+
+    Bool_t fUseHists;
+    
 public:
     MPedestalCam(const char *name=NULL, const char *title=NULL);
@@ -26,5 +31,4 @@
     
     void InitSize(const UInt_t i);
-    Int_t GetSize() const;
 
     void InitUseHists();
@@ -33,7 +37,15 @@
     MPedestalPix &operator[](Int_t i) const;
 
+    // Setters
+    void SetNumTotSlices(ULong_t n)    { fNumTotSlices = n; }
+    void SetNumExtractSlices(Byte_t n)   { fNumExtractSlices = n; }
+
+    // Getters
+    Int_t   GetSize()                          const;
     Float_t GetPedestalMin(const MGeomCam *cam) const;
     Float_t GetPedestalMax(const MGeomCam *cam) const;
-
+    Bool_t  IsUseHists()                       const  { return fUseHists; }
+    
+    
     void Print(Option_t *o="") const;
 
Index: trunk/MagicSoft/Mars/manalysis/MPedestalPix.h
===================================================================
--- trunk/MagicSoft/Mars/manalysis/MPedestalPix.h	(revision 2961)
+++ trunk/MagicSoft/Mars/manalysis/MPedestalPix.h	(revision 2969)
@@ -14,58 +14,59 @@
 {
 private:
-    Float_t fPedestal;     // mean value of pedestal (PMT offset)
-    Float_t fPedestalRms;  // root mean square / sigma  / standard deviation of pedestal
 
-    MHPedestalPixel *fHist; // Pointer to the histograms performing the fits, etc.      
+  Float_t fPedestal;     // mean value of pedestal (PMT offset)
+  Float_t fPedestalRms;  // root mean square / sigma  / standard deviation of pedestal
 
-    Float_t fMean;
-    Float_t fMeanErr;
-    Float_t fSigma;
-    Float_t fSigmaErr;
-    Float_t fProb;
-
-    Byte_t fFlags;
-
-    enum   { kFitted, kFitValid  };
-    
+  MHPedestalPixel *fHist; // Pointer to the histograms performing the fits, etc.      
+  
+  Float_t fMean;
+  Float_t fMeanErr;
+  Float_t fSigma;
+  Float_t fSigmaErr;
+  Float_t fProb;
+  
+  Byte_t fFlags;
+  
+  enum   { kFitted, kFitValid };
+  
 public:
-    MPedestalPix();
-    ~MPedestalPix();
-    
-    void Clear(Option_t *o="");
-
-    // Using histograms
-    void InitUseHists();
-    void FillHists(const Float_t f);
-    
+  MPedestalPix();
+  ~MPedestalPix();
+  
+  void Clear(Option_t *o="");
+  
+  // Using histograms
+  void InitUseHists();
+  void FillHists(const Float_t f);
+  
     // Setters
-    void SetPedestal(const Float_t f)    { fPedestal = f; }
-    void SetPedestalRms(const Float_t f) { fPedestalRms = f; }
-
-    void Set(const Float_t m, const Float_t r);
-
-    // Getters
-    Float_t GetPedestal()    const { return fPedestal; }
-    Float_t GetPedestalRms() const { return fPedestalRms; }
-
-    Float_t GetMean()        const { return fMean;     }
-    Float_t GetMeanErr()     const { return fMeanErr;  }
-    Float_t GetSigma()       const { return fSigma;    }
-    Float_t GetSigmaErr()    const { return fSigmaErr; }
-    Float_t GetProb()        const { return fProb;     }
-    
-    Bool_t IsValid()         const;
-    Bool_t IsFitted()        const;
-    Bool_t IsFitValid()      const;    
-    
-    // Fits
-    void FitCharge();   
-    Bool_t CheckFitValidity();
-    
-    // Draws
-    void Draw(Option_t *opt="")                 { fHist->Draw(opt); }
-    TObject *DrawClone(Option_t *opt="") const { return fHist->DrawClone(opt); }  
-
-    ClassDef(MPedestalPix, 1)	// Storage Container for Pedestal information of one pixel
+  void SetPedestal(const Float_t f)    { fPedestal = f; }
+  void SetPedestalRms(const Float_t f) { fPedestalRms = f; }
+  
+  void Set(const Float_t m, const Float_t r);
+  
+  // Getters
+  Float_t GetPedestal()    const { return fPedestal; }
+  Float_t GetPedestalRms() const { return fPedestalRms; }
+  
+  Float_t GetMean()        const { return fMean;     }
+  Float_t GetMeanErr()     const { return fMeanErr;  }
+  Float_t GetSigma()       const { return fSigma;    }
+  Float_t GetSigmaErr()    const { return fSigmaErr; }
+  Float_t GetProb()        const { return fProb;     }
+  
+  Bool_t IsValid()         const;
+  Bool_t IsFitted()        const;
+  Bool_t IsFitValid()      const;
+  
+  // Fits
+  void FitCharge();   
+  Bool_t CheckFitValidity();
+  
+  // Draws
+  void Draw(Option_t *opt="")                 { fHist->Draw(opt); }
+  TObject *DrawClone(Option_t *opt="") const { return fHist->DrawClone(opt); }  
+  
+  ClassDef(MPedestalPix, 1)	// Storage Container for Pedestal information of one pixel
 };
 